#=========================================================
# LocusMeshMaker.py
#
# Blender2.41
# Python Release 2.4.3 29 March 2006
#
# AjOՂbVɂXNvg
#
# g
#   1 IuWFNgI
#   2 t[ʒuݒ
#   3 ʒu֌Wݒ (X1,Y1,Z1)-(X2,Y2,Z2)
#     IuWFNg̒S(0,0,0)ƂȂ܂
#     o[Wł Plane ^Cvł܂
#
# Auther: keina
#
# See Also:
#   http://www.geocities.co.jp/SiliconValley-Cupertino/2019/blender/PythonDocJpn/index.html
#   http://jmsoler.free.fr/didacticiel/blender/tutor/index.htm
#   http://pleac.sourceforge.net/pleac_python/index.html
#   http://blenderartists.org/ http://blenderartists.org/forum/
#   http://www.python.org/  http://www.python.org/doc/
#
# History:
#   2006.07.03(Mon)   Created
#
# CopyRight(c) 2006 K.Keina
# Mail: keines@ps.sakura.ne.jp
# Web : http://keines.gozaru.jp/blender/
#=========================================================

print '--- LocusMeshMaker.py ---'
import Blender
from Blender import Draw, BGL,NMesh,Object

# Other variables
Title		= 'LocusMeshMaker : From Path Anime'
Version		= 'ver.2006.07.03(Mon) 02:15'
Author		= ' by keines'
VerWidth	= Draw.GetStringWidth(Version+Author)
MainWidth	= VerWidth+Draw.GetStringWidth(Title)

# + BaseValue
SpcWidth	= 20
BaseHeight	= 20
BtnHeight	= 20
ValueRange	= 100.00   # Max=100.00,Min=-100.00
FrameRange	= 1000

# + Label
MainLabel	= [['Start',0],['End',0],['X',0],['Y',0],['Z',0],['Execute',0],['Exit',0]]
MainLabel_Start	= 0
MainLabel_End	= 1
MainLabel_X	= 2
MainLabel_Y	= 3
MainLabel_Z	= 4
MainLabel_Execute=5
MainLabel_Exit	=6
for i in range(len(MainLabel)):
    MainLabel[i][1]=Draw.GetStringWidth(MainLabel[i][0])+SpcWidth
SliderBtnWidth	= (Draw.GetStringWidth('0 - '+str(ValueRange))+MainLabel[MainLabel_X][1])*2+4
SliderFrameWidth= (Draw.GetStringWidth(' '+str(FrameRange))+MainLabel[MainLabel_Start][1])*2+4

# + SliderButton
#   - Frame Start, End
#   - Diffuse (X1,Y1,Z1)-(X2,Y2,Z2)
SliderBtn	= [Draw.Create(0),Draw.Create(Blender.Get('endframe')),
                   Draw.Create(0.0),Draw.Create(0.0),Draw.Create(0.0),
                   Draw.Create(1.0),Draw.Create(0.0),Draw.Create(0.0)]
SliderBtn_Start = 0
SliderBtn_End   = 1
SliderBtn_X1 = 2
SliderBtn_Y1 = 3
SliderBtn_Z1 = 4
SliderBtn_X2 = 5
SliderBtn_Y2 = 6
SliderBtn_Z2 = 7

# Event
Event_None	= 0
Event_Execute	= 1
Event_Exit	= 2

def DrawGui():
    global SliderBtn
    
    # --- Init Screen ---
    BGL.glClearColor(0.6, 0.6, 0.6, 0.0)
    BGL.glClear(Blender.BGL.GL_COLOR_BUFFER_BIT)
    BGL.glColor3f(0.1, 0.1, 0.15) # Text Color
    # --- Get Screen Size ---
    size=Blender.BGL.Buffer(Blender.BGL.GL_FLOAT, 4)
    Blender.BGL.glGetFloatv(Blender.BGL.GL_SCISSOR_BOX, size)
    size= size.list
    # FLOAT -> INT
    for s in range(4): size[s]=int(size[s])
    # Base Position
    x=20
    y=size[3]-BaseHeight
    # + Title
    BGL.glRasterPos2f(x, y)
    Draw.Text(Title)
    
    y-=BaseHeight*2
    
    h=BtnHeight+10
    k=SliderBtn_X1
    for i in [0,1]:
      SliderBtn[SliderBtn_Start+i]=Draw.Slider(MainLabel[MainLabel_Start+i][0]+' : ',Event_None,x+i*(SliderFrameWidth+6),y,SliderFrameWidth, BtnHeight, SliderBtn[SliderBtn_Start+i].val, 1, FrameRange)
      for j in range(3): # 0 1 2
        SliderBtn[k+j]=Draw.Slider(MainLabel[MainLabel_X+j][0]+str(i)+' : ',Event_None,x+j*(SliderBtnWidth+6),y-h-10-i*(BtnHeight+4),SliderBtnWidth, BtnHeight, SliderBtn[k+j].val, -100.0, 100.0)
      k=SliderBtn_X2
    
    MaxWidth=x+2*(SliderBtnWidth+6)+SliderBtnWidth
    # Btn Execute
    k=MainLabel[MainLabel_Execute][1]+SpcWidth
    Draw.Button (MainLabel[MainLabel_Execute][0],Event_Execute,MaxWidth-k,y,k,BaseHeight,"")
    
    y-=(BtnHeight+10)+h
    
    # + Version
    y-=BaseHeight+6+10
    #x=20
    BGL.glRasterPos2f(MaxWidth-VerWidth, y)
    Draw.Text(Version+Author)
    
    # + Exit Button
    y-=BaseHeight
    Draw.Button (MainLabel[MainLabel_Exit][0],Event_Exit,x,y,MainLabel[MainLabel_Exit][1]+SpcWidth,BaseHeight,"")

def ExecuteFunction():
  try:
    ss=SliderBtn[SliderBtn_Start].val
    ee=SliderBtn[SliderBtn_End].val
    x1=SliderBtn[SliderBtn_X1].val
    y1=SliderBtn[SliderBtn_Y1].val
    z1=SliderBtn[SliderBtn_Z1].val
    x2=SliderBtn[SliderBtn_X2].val
    y2=SliderBtn[SliderBtn_Y2].val
    z2=SliderBtn[SliderBtn_Z2].val
    
    # + IuWFNg̑I`FbN
    OB=Blender.Object.GetSelected()
    if len(OB)==0:
      Draw.PupMenu('No Selected..')
      return
    #   - IIuWFNg
    OB=OB[0]
    
    # + t[X^[gʒuɐݒ
    scene=Blender.Scene.getCurrent()
    rc=scene.getRenderingContext()
    #rc.currentFrame(ss)
    #Blender.Redraw()
    
    # + t[𓮂ă|CgǉĂ
    print "Collect Vertexs.."
    me= NMesh.GetRaw()
    cnt=ee+1
    k=0
    for i in range(ss, cnt):
      # - t[Pi߂
      rc.currentFrame(i)
      Blender.Redraw()
      
      # - W擾
      [x,y,z,w]=OB.getMatrix()[3]
      Blender.Window.SetCursorPos([x,y,z])
      
      # - Wǉ
      v=NMesh.Vert(x+x1,y+y1,z+z1)
      me.verts.append(v)
      
      v=NMesh.Vert(x+x2,y+y2,z+z2)
      me.verts.append(v)
      
      print "% 3d : ( % .3f , % .3f , % .3f )" % (k,x,y,z)
      k+=1

    # + ʂ쐬
    #   - ʂ݂ĎvɃCfbNXǉĂ
    #     ʂ̌ʂ
    #
    # @@Index  [1]    [3]    [5]    [7]    
    #                       
    #            [0]  [2]  [4]  [6]  
    print "\nMake Faces.."
    cnt=len(me.verts)-2
    k=0
    # 1..cnt :2
    for i in range(1,cnt,2):
      f=NMesh.Face()
      f.v.append(me.verts[i])
      f.v.append(me.verts[i-1])
      f.v.append(me.verts[i+1])
      f.v.append(me.verts[i+2])
      me.faces.append(f)
      print "% 3d : ( % 3d , % 3d , % 3d , % 3d )" % (k,i,i-1,i+1,i+2)
      k+=1
    
    # + Ō̏o
    #   - OtƏ㏑
    #   - 󔒂ɂĂƏd`FbNĖOŕtĂ
    NMesh.PutRaw(me,'',1)
    
    rc.currentFrame(ee)
    Blender.Redraw()
  except:
    Draw.PupMenu('Error..')
  print "\nScript Finish.\n"

# {^Cxg
def ButtonEvent(evt):
    if (evt==Event_Execute): ExecuteFunction()
    elif (evt==Event_Exit) : Draw.Exit()

# L[Cxg
def KeyEvent(evt, val):
    # val: 1=KeyDown 0=KeyUp
    if (not val) :
        return
    if evt in [Draw.ESCKEY, Draw.QKEY]:
        Draw.Exit()

Draw.Register(DrawGui, KeyEvent, ButtonEvent)
